GIT-SHORTLOG(1)

NAME
git-shortlog - Summarize 'git log' output

SYNOPSIS

git log --pretty=short | git shortlog [-h] [-n] [-s] [-e] [-w]
git shortlog [-n|--numbered] [-s|--summary] [-e|--email] [-w[<width>[,<indent1>[,<indent2>]]]] [<committish>...]

DESCRIPTION

Summarizes git log output in a format suitable for inclusion in release announcements. Each commit will be grouped by author and the first line of the commit message will be shown.

Additionally, "[PATCH]" will be stripped from the commit description.

OPTIONS

-h, --help
    Print a short usage message and exit.

-n, --numbered
    Sort output according to the number of commits per author instead of author alphabetic order.

-s, --summary
    Suppress commit description and provide a commit count summary only.

-e, --email
    Show the email address of each author.

-w[<width>[,<indent1>[,<indent2>]]]
    Linewrap the output by wrapping each line at width. The first line of each entry is indented by indent1 spaces, and the second and subsequent lines are indented by indent2 spaces. width, indent1, and indent2 default to 76, 6 and 9 respectively.

MAPPING AUTHORS

The .mailmap feature is used to coalesce together commits by the same person in the shortlog, where their name and/or email address was spelled differently.

If the file .mailmap exists at the toplevel of the repository, or at the location pointed to by the mailmap.file configuration option, it is used to map author and committer names and email addresses to canonical real names and email addresses.

In the simple form, each line in the file consists of the canonical real name of an author, whitespace, and an email address used in the commit (enclosed by < and >) to map to the name. For example:

    Proper Name <commit@email.xx>

The more complex forms are:

    <proper@email.xx> <commit@email.xx>

which allows mailmap to replace only the email part of a commit, and:

    Proper Name <proper@email.xx> <commit@email.xx>

which allows mailmap to replace both the name and the email of a commit matching the specified commit email address, and:

    Proper Name <proper@email.xx> Commit Name <commit@email.xx>

which allows mailmap to replace both the name and the email of a commit matching both the specified commit name and email address.

Example 1: Your history contains commits by two authors, Jane and Joe, whose names appear in the repository under several forms:

    Joe Developer <joe@example.com>
    Joe R. Developer <joe@example.com>
    Jane Doe <jane@example.com>
    Jane Doe <jane@laptop.(none)>
    Jane D. <jane@desktop.(none)>

Now suppose that Joe wants his middle name initial used, and Jane prefers her family name fully spelled out. A proper .mailmap file would look like:

    Jane Doe         <jane@desktop.(none)>
    Joe R. Developer <joe@example.com>

Note how there is no need for an entry for <jane@laptop.(none)>, because the real name of that author is already correct.

Example 2: Your repository contains commits from the following authors:

    nick1 <bugs@company.xx>
    nick2 <bugs@company.xx>
    nick2 <nick2@company.xx>
    santa <me@company.xx>
    claus <me@company.xx>
    CTO <cto@coompany.xx>

Then you might want a .mailmap file that looks like:

    <cto@company.xx>                       <cto@coompany.xx>
    Some Dude <some@dude.xx>         nick1 <bugs@company.xx>
    Other Author <other@author.xx>   nick2 <bugs@company.xx>
    Other Author <other@author.xx>         <nick2@company.xx>
    Santa Claus <santa.claus@northpole.xx> <me@company.xx>

Use hash # for comments that are either on their own line, or after the email address.

AUTHOR

Written by Jeff Garzik <jgarzik@pobox.com>

DOCUMENTATION

Documentation by Junio C Hamano.

GIT

Part of the git(1) suite